#!/bin/sh

#
# Для успешной работы нужно выполнолнить следующую комманду:
# echo "$USER ALL=(ALL) NOPASSWD: /sbin/shutdown" | sudo tee -a /etc/sudoers.d/$USER
# Цель: комманда shutdown запускалась от пользователя не спрашивая пароля.
#

#export DISPLAY=:0
#/run/user/$UID

# Установим переменные.
doShutdown=no
cancelShutdown=no

readSavedTimeout() {
    timeout=$(</tmp/shut.cfg)
    timeout="${timeout:-5}"
    echo $timeout
}

askandsetNewTimeout() {
#	newtimeout=$(zenity --timeout=$1 --entry --title="Время до выключения: ${timeout}" \
#	--text="Установить новое время до выключения компьютера" )
	newtimeout=$(zenity --timeout=10 --scale --value=${timeout} --max-value=30 \
	--title="Установка Времения до выключения" \
	--text="Установить новое время до выключения компьютера" )
	local statusQuery=$?
#	echo statusQuery=$statusQuery
	if [ $statusQuery == 0 ]; then
		echo ${newtimeout} > /tmp/shut.cfg
#		zenity --notification --text "Устанoвлено новое время до выключения компютера ${newtimeout} минут"
		notify-send -t 2000 "Устанoвлено новое время до выключения компютера ${newtimeout} минут"
	fi
}

execIfMonitorOn() {
    echo "Моник горит"
    sudo shutdown -c
}

execIfMonitorOff() {
    echo "надо выключать"
    sudo shutdown -h $(( ${timeout} * 60 ))
}

# Прочтем сохранённое значение из файла
readSavedTimeout
# Попросим установить новое время до выключения компа
askandsetNewTimeout

# бесконечный цикл
while sleep 1
do
echo Start
# получим состояние монитора в переменную (значение On/Off)
statusMonitor=$(xset -display :0 -q | grep "Monitor is" | awk '{print $3}')

if [ $statusMonitor == "On" ] && [ $doShutdown == "no" ]; then
doShutdown=yes
cancelShutdown=no
execIfMonitorOn
fi

if [ $statusMonitor == "Off" ] && [ $cancelShutdown == "no" ]; then
doShutdown=no
cancelShutdown=yes
execIfMonitorOff
fi

#echo statusMonitor=$statusMonitor doShutdown=$doShutdown cancelShutdown=$cancelShutdown

done

exit
